﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Threading.Tasks;

namespace WebPortal.Models
{
    public class Visite
    {
        
        public int Id { get; set; }
        public string VisitId { get; set; }
        public TipoVisita Tipo { get; set; }
        [Display(Name = "Tipo visita")]
        public string CodiceTipoVisita { get; set; }
        public int IdStato { get; set; }
        public StatoVisita Stato { get; set; } 

        [Required(ErrorMessage = "Il Container è un dato obbligatorio")]
        [MinLength(11, ErrorMessage = "La lunghezza del codice contenitore deve essere 11")] 
        [MaxLength(11, ErrorMessage = "La lunghezza del codice contenitore deve essere 11")]
        [RegularExpression(@"^[A-Z]{3}[UJZ]{1}[0-9]{7}$", ErrorMessage ="Codice contenitore formalmente errato")]
        public string Container { get; set; }
        
        public string Sigillo { get; set; }
        [Required(ErrorMessage = "Lo Spedizioniere è un dato obbligatorio")]
        public string Spedizioniere { get; set; }
        [Required(ErrorMessage = "L'area di messa a disposizione è un dato obbligatorio")]
        public string Area { get; set; } = "";
        public string Traffico { get; set; } = "IM";
        
        [Display(Name = "Data visita")]
        [DataType(DataType.Date)]
        [DisplayFormat(DataFormatString = "{0:dd-MM-yyyy}", ApplyFormatInEditMode = true)]
        public DateTime DataProgrammata { get; set; }
        public DateTimeOffset TimestampRegistrazione { get; set; }
        public string UsernameRegistrazione { get; set; }
        public DateTimeOffset? TimestampUltimaModifica { get; set; } = null;
        public string UsernameUltimaModifica { get; set; } = "";
        public ModuloVisita Modulo { get; set; } = null;
        public List<Foto> ListaFoto { get; set; } = new List<Foto>();
        public List<OperazioniVisita> Operazioni { get; set; } = new List<OperazioniVisita>();
    }
}
